﻿(vlr-command-reactor ; создаем командный реактор
  "AUR_2014-CommandReactor" ; Строка-идентификатор
  '(
    (:vlr-commandwillstart . aur_2014-vlr-command-start) ; Имя lisp-функции, выполняемой
											; при CommandWillStart – т.е. в момент, когда команда уже вызвана, но еще
											; не запущена
    (:vlr-commandended . aur_2014-vlr-command-end)
											; Имя lisp-функции, выполняемой после окончания работы команды
											; но при этом управление еще обратно в AutoCAD не передано
    )
  ) ;_ end of vlr-command-reactor

(defun aur_2014-vlr-command-start (react cmd)
  (setq cmd ; установим переменной cmd новое значение
         (strcase ; 3. Значение из п.2. - гарантированно строка. Переведем ее в верхний регистр
           (car ; 2. Из п.1 получим первую часть списка
             cmd ; 1. Возьмем переданный параметра
             ) ;_ end of car
           ) ;_ end of strcase
        ) ;_ end of setq
  (if (wcmatch cmd "*TEXT") ; Если команда оканчивается на символы TEXT, то
    (progn
      (setq *aur_2014-cur-textstyle* (getvar "textstyle")) ; Запомним старое значение
														; TEXTSTYLE
      (setvar "textstyle" "AUR_2014") ; А потом установим новое значение
      ) ;_ end of progn
    ) ;_ end of if
  ) ;_ end of defun

(defun aur_2014-vlr-command-end (react cmd)
  (setq cmd ; установим переменной cmd новое значение
         (strcase ; 3. Значение из п.2. - гарантированно строка. Переведем ее в верхний регистр
           (car ; 2. Из п.1 получим первую часть списка
             cmd ; 1. Возьмем переданный параметра
             ) ;_ end of car
           ) ;_ end of strcase
        ) ;_ end of setq
  (if (wcmatch cmd "*TEXT"); Если команда оканчивается на символы TEXT, то
    (progn
      (if *aur_2014-cur-textstyle* ; Если раньше была сохранено значение TEXTSTYLE, то
        (setvar "textstyle" *aur_2014-cur-textstyle*) ; Восстанавливаем старое значение
														; TEXTSTYLE
        ) ;_ end of if
      (setq *aur_2014-cur-textstyle* nil) ; И уничтожаем "память" о старом значении
														; TEXTSTYLE
      ) ;_ end of progn
    ) ;_ end of if
  ) ;_ end of defun
